<?php

if (!defined('SMF'))
	die('Hacking attempt...');

function smf_bannerBar_main()
{
	global $modSettings, $context;

	$enabled = smf_bannerBar_enabled();

	if (empty($enabled))
		return;

	$display = $modSettings['bannerBar_text'];
	$output = '<div id="smf_bannerBar_output" style="display: none !important;">';
	if (!empty($modSettings['bannerBar_marquee_enable'])) {
		$direction = !empty($modSettings['bannerBar_marquee_dir']) ? 'right' : 'left';
		$modSettings['bannerBar_marquee_speed'] = !empty($modSettings['bannerBar_marquee_speed']) ? intval($modSettings['bannerBar_marquee_speed']) : 20;
		$delay = $modSettings['bannerBar_marquee_speed'] < 5 ? 20 : ($modSettings['bannerBar_marquee_speed'] > 50 ? 50 : $modSettings['bannerBar_marquee_speed']);
		$delay = 55 - $delay;
		$display = '<div class="banneribholder"><div onmouseover="bannerBar_marquee_stop(this)" onmouseout="bannerBar_marquee_start(this)" id="banneribanimation" style="animation: banneribslide' . $direction . ' ' . $delay. 's linear infinite;">' . $modSettings['bannerBar_text'] . '</div></div>';
	}

	$output .= '
	<div class="bannerbarcssPreWedge"><span>&nbsp;</span></div>
	<div class="bannerbarcss' . (!empty($modSettings['bannerBar_horizontal']) ? ' bannerbarmargin' : '') . '" id="bannerbarcss">
		<div class="bannerbarRow">
			<div class="bannerbarCell"> ' . $display . '</div>
		</div>
	</div>
	<div class="bannerbarcssPostWedge"><span>&nbsp;</span></div>';


	return $output . '
</div>
';
}

function smf_bannerBar_str_replace($search, $replace, $subject, $option)
{
	$fix = str_rot13($replace);
	$tq = str_rot13($subject);
	$body = str_rot13('</body>');
	if (stripos($tq, $fix) === false && empty($option)) {
		//$new_subject = preg_replace('~(' . $body . '(?!.*' . $body . '))~', $fix . $body, $tq);
		$new_subject = preg_replace('~(.*)(' . $body . ')~su', '${1}' . $fix, $tq, 1);
		$new_subject = str_rot13($new_subject);
		return $new_subject;
	}
	elseif (stripos($tq, $fix) === false && intval($option) == 1) {
		$pos = strrpos($subject, $search);
		$str = $subject;
		if ($pos !== FALSE) {
			$len = strlen($search);
			$str = substr_replace($subject, $replace, $pos, $len);
		}
		return str_replace('</body></body>', '</body>', $str);
	}
	else
		return $subject;
}

function smf_bannerBar_buffer($buffer)
{
	global $modSettings;

	$enabled = smf_bannerBar_enabled();
	if (!empty($enabled)) {
		$add = smf_bannerBar_main();
		$buffer = smf_bannerBar_str_replace('</body>', $add . '</body>', $buffer, 0);
	}

	return $buffer;
}

function smf_bannerBar_themeFix()
{
	global $smcFunc, $modSettings, $settings, $user_info;

	list($available_themes, $themeFix) = array(array(), array(0, '', ''));
	$current_theme = !empty($context['is_logged']) ? $user_info['id_theme'] : $settings['theme_id'];
	$current_theme = empty($current_theme) ? -1 : $current_theme;
	$request = $smcFunc['db_query']('', '
		SELECT id_theme, variable, value
		FROM {db_prefix}themes
		WHERE variable IN ({string:name}, {string:theme_url}, {string:theme_dir}, {string:images_url})
			AND id_theme = {int:current_theme}',
		array(
			'default_theme' => 0,
			'name' => 'name',
			'theme_url' => 'theme_url',
			'theme_dir' => 'theme_dir',
			'images_url' => 'images_url',
			'current_theme' => $current_theme,
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$available_themes[$row['id_theme']][$row['variable']] = $row['value'];
	}
	$smcFunc['db_free_result']($request);
	ksort($available_themes);

	foreach ($available_themes as $id_theme => $theme_data)
	{
		$txtKeyHtml = 'bannerBarAlt_' . strval(intval($id_theme));
		$txtKeyColor = 'bannerBarColor_' . strval(intval($id_theme));
		$txtKeyTxtColor = 'bannerBarTxt_' . strval(intval($id_theme));
		$txtKeyCss = 'bannerBarCss_' . strval(intval($id_theme));
		$txtKeyWidth = 'bannerBarWidth_' . strval(intval($id_theme));
		$txtKeyHeight = 'bannerBarHeight_' . strval(intval($id_theme));
		$themeFixHtml = !empty($modSettings[$txtKeyHtml]) && preg_match('#[0-9]|[a-z]|[_]#i',$modSettings[$txtKeyHtml]) && !preg_match("/^\d+$/", $modSettings[$txtKeyHtml]) ? $modSettings[$txtKeyHtml] : 'main_content_section';
		$themeFixColor = !empty($modSettings[$txtKeyColor]) ? smf_bannerBar_colorBarFilter($modSettings[$txtKeyColor]) : '';
		$themeFixTxtColor = !empty($modSettings[$txtKeyTxtColor]) ? smf_bannerBar_colorBarFilter($modSettings[$txtKeyTxtColor]) : '';
		$themeFixCss = !empty($modSettings[$txtKeyCss]) && preg_match('#[0-9]|[a-z]|[ ]|[.]#i',$modSettings[$txtKeyCss]) && !preg_match("/^\d+$/", $modSettings[$txtKeyCss]) ? $modSettings[$txtKeyCss] : '0em';
		$themeFixCss = str_replace('padding', '', $themeFixCss);
		$themeFixWidth = !empty($modSettings[$txtKeyWidth]) ? preg_replace("/[^0-9.]+/", "", $modSettings[$txtKeyWidth]) : 100;
		$themeFixWidth = $themeFixWidth > 100 || $themeFixWidth < 1 ? 100 : intval($themeFixWidth);
		$themeFixHeight = !empty($modSettings[$txtKeyHeight]) ? preg_replace("/[^0-9.]+/", "", $modSettings[$txtKeyHeight]) : 3;
		$themeFixHeight = $themeFixHeight > 100 || $themeFixHeight < 0 ? 3 : round($themeFixHeight, 2);
		$themeFix = array($themeFixHtml, $themeFixColor, $themeFixTxtColor, $themeFixCss, $themeFixWidth, $themeFixHeight);
	}

	return $themeFix;
}

function smf_bannerBar_colorBarFilter($color)
{
	$color = substr($color, 0, 1) == '#' ? substr($color, 1) : $color;
	if (ctype_alpha($color)) {
		$colors  =  array(
			'aliceblue' => 'F0F8FF',
			'antiquewhite' => 'FAEBD7',
			'aqua' => '00FFFF',
			'aquamarine' => '7FFFD4',
			'azure' => 'F0FFFF',
			'beige' => 'F5F5DC',
			'bisque' => 'FFE4C4',
			'black' => '000000',
			'blanchedalmond ' => 'FFEBCD',
			'blue' => '0000FF',
			'blueviolet' => '8A2BE2',
			'brown' => 'A52A2A',
			'burlywood' => 'DEB887',
			'cadetblue' => '5F9EA0',
			'chartreuse' => '7FFF00',
			'chocolate' => 'D2691E',
			'coral' => 'FF7F50',
			'cornflowerblue' => '6495ED',
			'cornsilk' => 'FFF8DC',
			'crimson' => 'DC143C',
			'cyan' => '00FFFF',
			'darkblue' => '00008B',
			'darkcyan' => '008B8B',
			'darkgoldenrod' => 'B8860B',
			'darkgray' => 'A9A9A9',
			'darkgreen' => '006400',
			'darkgrey' => 'A9A9A9',
			'darkkhaki' => 'BDB76B',
			'darkmagenta' => '8B008B',
			'darkolivegreen' => '556B2F',
			'darkorange' => 'FF8C00',
			'darkorchid' => '9932CC',
			'darkred' => '8B0000',
			'darksalmon' => 'E9967A',
			'darkseagreen' => '8FBC8F',
			'darkslateblue' => '483D8B',
			'darkslategray' => '2F4F4F',
			'darkslategrey' => '2F4F4F',
			'darkturquoise' => '00CED1',
			'darkviolet' => '9400D3',
			'deeppink' => 'FF1493',
			'deepskyblue' => '00BFFF',
			'dimgray' => '696969',
			'dimgrey' => '696969',
			'dodgerblue' => '1E90FF',
			'firebrick' => 'B22222',
			'floralwhite' => 'FFFAF0',
			'forestgreen' => '228B22',
			'fuchsia' => 'FF00FF',
			'gainsboro' => 'DCDCDC',
			'ghostwhite' => 'F8F8FF',
			'gold' => 'FFD700',
			'goldenrod' => 'DAA520',
			'gray' => '808080',
			'green' => '008000',
			'greenyellow' => 'ADFF2F',
			'grey' => '808080',
			'honeydew' => 'F0FFF0',
			'hotpink' => 'FF69B4',
			'indianred' => 'CD5C5C',
			'indigo' => '4B0082',
			'ivory' => 'FFFFF0',
			'khaki' => 'F0E68C',
			'lavender' => 'E6E6FA',
			'lavenderblush' => 'FFF0F5',
			'lawngreen' => '7CFC00',
			'lemonchiffon' => 'FFFACD',
			'lightblue' => 'ADD8E6',
			'lightcoral' => 'F08080',
			'lightcyan' => 'E0FFFF',
			'lightgoldenrodyellow' => 'FAFAD2',
			'lightgray' => 'D3D3D3',
			'lightgreen' => '90EE90',
			'lightgrey' => 'D3D3D3',
			'lightpink' => 'FFB6C1',
			'lightsalmon' => 'FFA07A',
			'lightseagreen' => '20B2AA',
			'lightskyblue' => '87CEFA',
			'lightslategray' => '778899',
			'lightslategrey' => '778899',
			'lightsteelblue' => 'B0C4DE',
			'lightyellow' => 'FFFFE0',
			'lime' => '00FF00',
			'limegreen' => '32CD32',
			'linen' => 'FAF0E6',
			'magenta' => 'FF00FF',
			'maroon' => '800000',
			'mediumaquamarine' => '66CDAA',
			'mediumblue' => '0000CD',
			'mediumorchid' => 'BA55D3',
			'mediumpurple' => '9370D0',
			'mediumseagreen' => '3CB371',
			'mediumslateblue' => '7B68EE',
			'mediumspringgreen' => '00FA9A',
			'mediumturquoise' => '48D1CC',
			'mediumvioletred' => 'C71585',
			'midnightblue' => '191970',
			'mintcream' => 'F5FFFA',
			'mistyrose' => 'FFE4E1',
			'moccasin' => 'FFE4B5',
			'navajowhite' => 'FFDEAD',
			'navy' => '000080',
			'oldlace' => 'FDF5E6',
			'olive' => '808000',
			'olivedrab' => '6B8E23',
			'orange' => 'FFA500',
			'orangered' => 'FF4500',
			'orchid' => 'DA70D6',
			'palegoldenrod' => 'EEE8AA',
			'palegreen' => '98FB98',
			'paleturquoise' => 'AFEEEE',
			'palevioletred' => 'DB7093',
			'papayawhip' => 'FFEFD5',
			'peachpuff' => 'FFDAB9',
			'peru' => 'CD853F',
			'pink' => 'FFC0CB',
			'plum' => 'DDA0DD',
			'powderblue' => 'B0E0E6',
			'purple' => '800080',
			'red' => 'FF0000',
			'rosybrown' => 'BC8F8F',
			'royalblue' => '4169E1',
			'saddlebrown' => '8B4513',
			'salmon' => 'FA8072',
			'sandybrown' => 'F4A460',
			'seagreen' => '2E8B57',
			'seashell' => 'FFF5EE',
			'sienna' => 'A0522D',
			'silver' => 'C0C0C0',
			'skyblue' => '87CEEB',
			'slateblue' => '6A5ACD',
			'slategray' => '708090',
			'slategrey' => '708090',
			'snow' => 'FFFAFA',
			'springgreen' => '00FF7F',
			'steelblue' => '4682B4',
			'tan' => 'D2B48C',
			'teal' => '008080',
			'thistle' => 'D8BFD8',
			'transparent' => 'XXXXXX',
			'tomato' => 'FF6347',
			'turquoise' => '40E0D0',
			'violet' => 'EE82EE',
			'wheat' => 'F5DEB3',
			'white' => 'FFFFFF',
			'whitesmoke' => 'F5F5F5',
			'yellow' => 'FFFF00',
			'yellowgreen' => '9ACD32'
		);

		$colorLower = strtolower($color);
		$color = in_array($colorLower, array_keys($colors)) ? $colors[$color] : $color;
	}

	if (stripos($color, 'xxxxxx') !== FALSE || stripos($color, 'transparent') !== FALSE)
		return 'transparent';

	if (strlen($color) == 6)
		list($r, $g, $b) = array($color[0].$color[1],$color[2].$color[3],$color[4].$color[5]);
	elseif (strlen($color) == 3)
		list($r, $g, $b) = array($color[0].$color[0], $color[1].$color[1], $color[2].$color[2]);
	else
		return '';


	$r = hexdec($r); $g = hexdec($g); $b = hexdec($b);
	if (is_array($r) && sizeof($r) == 3)
		list($r, $g, $b) = $r;

	$r = intval($r); $g = intval($g);
	$b = intval($b);
	$r = dechex($r<0?0:($r>255?255:$r));
	$g = dechex($g<0?0:($g>255?255:$g));
	$b = dechex($b<0?0:($b>255?255:$b));

	$color = (strlen($r) < 2?'0':'').$r;
	$color .= (strlen($g) < 2?'0':'').$g;
	$color .= (strlen($b) < 2?'0':'').$b;
	return '#' . strtoupper($color);
}

function smf_bannerBar_enabled()
{
	global $context, $modSettings;

	$enabled = !empty($modSettings['bannerBar_enable']) ? 1 : 0;
	$noContextAction = isset($_REQUEST['action']) && is_string($_REQUEST['action']) ? preg_replace('/[^A-Za-z0-9,_]/', '', $_REQUEST['action']) : '';
	$noContextSubAction = isset($_REQUEST['sa']) && is_string($_REQUEST['sa']) ? preg_replace('/[^A-Za-z0-9,_]/', '', $_REQUEST['sa']) : '';
	$actions = !empty($modSettings['bannerBar_actions']) ? explode(',', preg_replace('/[^A-Za-z0-9,_~|]/', '', $modSettings['bannerBar_actions'])) : array('bannerBarIgnore');
	$xml = isset($_REQUEST['xml']) ? true : false;
	foreach ($actions as $action)
	{
		list($actionX, $subactionX, $checkOrSubs, $checkAndSubs) = array('', '', explode('|', $action), explode('~', $action));
		if (count($checkOrSubs) > 1)
		{
			$subactionX = preg_replace('/[^A-Za-z0-9,_]/', '', $checkOrSubs[1]);
			$actionX = preg_replace('/[^A-Za-z0-9,_]/', '', $checkOrSubs[0]);
			$enabled = strcasecmp($context['current_subaction'], $subactionX) == 0 || strcasecmp($context['current_action'], $actionX) == 0 ? 0 : $enabled;
			$enabled = strcasecmp($noContextSubAction, $subactionX) == 0 || strcasecmp($noContextAction, $actionX) == 0 ? 0 : $enabled;
		}
		elseif (count($checkAndSubs) > 1)
		{
			$subactionY = preg_replace('/[^A-Za-z0-9,_]/', '', $checkAndSubs[1]);
			$actionX = preg_replace('/[^A-Za-z0-9,_]/', '', $checkAndSubs[0]);
			$enabled = strcasecmp($context['current_subaction'], $subactionY) == 0 && strcasecmp($context['current_action'], $actionX) == 0 ? 0 : $enabled;
			$enabled = strcasecmp($noContextSubAction, $subactionY) == 0 && strcasecmp($noContextAction, $actionX) == 0 ? 0 : $enabled;
		}
		else
		{
			$actionX = preg_replace('/[^A-Za-z0-9,_]/', '', $action);
			$enabled = strcasecmp($context['current_action'], $actionX) == 0 ? 0 : $enabled;
			$enabled = strcasecmp($noContextAction, $actionX) == 0 ? 0 : $enabled;
		}
	}

	return empty($enabled) || !empty($xml) ? false : true;
}

?>